unit UI;
{*
 * Konnekt Delphi SDK (Software Development Kit)
 *
 * Nagwek: UI shared
 * Modyfikowany: 2006-08-31
 * Zgodny z wersj: 0.6.22.x
 * Info: nagwek potrzebny przy korzystaniu z interfejsu dla Windowsa.
 *
 * rodowisko: Borland Delphi 7
 *
 * http://www.konnekt.info/
 *
 * (C) 2002-2006 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! 
 *}

interface

uses
  Plug;

function UIIcon(type_: Integer; net: Integer; id: Integer; frame: Integer): Integer;
    // typ - 4b | net - 8b | id - 16b | frame - 4b

const
  ICON_BLANK = $F;
  IT_LOGO = 2;
  IT_OVERLAY = 3;
  IT_STATUS = 4;
  IT_MESSAGE = 5;
  IT_BLANK_MASK = $80000000;

const
  IMIB_        = $FF000000;
  IMIB_CFG     = $11000000; ///< Maska dla ustawie programu.
  IMIB_CNT     = $13000000; ///< Maska dla ustawie kontaktu.
  IMIB_PROFILE = $12000000;

type IML_enum = (
  IML_NONE = $0,
  IML_16 = $1, ///< lista 16x16
  IML_32 = $2, ///< lista 32x32
  IML_ICO = $100,  ///< samodzielna ikonka (uywana rzadko)
  IML_ICO2 = $200, ///< samodzielna ikonka 2 (uywana bardzo rzadko)
  IML_BMP = $1000, ///< samodzielna bitmapa (uywana rzadko)
  IML_16_32 = IML_16 or IML_32
  );

type
  tIconParams = packed record
    size: Smallint;
    bits: Shortint;
  end;

type
  sUIIconRegisterPrt = ^sUIIconRegister;
  sUIIconRegister = packed record
    s_size: Word;
    ID: Integer; ///< ID dodawanej ikonki.
    target: IML_enum;  ///< Listy do ktrych zostanie przydzielona ikonka.
    URL: PChar; ///< URL kierujcy do pliku/zasobu.
    imgType: Integer; ///< Typ obrazu - 0 - bitmapa, 1 - ikonka
    imgInst: Longword; ///< Biblioteka z ktrej chcemy wczyta obraz
    imgId: Integer;   ///< Identyfikator obrazu
    imgHandle: THandle; ///< Uchwyt obrazu.
    case Integer of
      1: (maskHandle: THandle); ///< Uchwyt maski, jeli w imgHandle jest Bitmapa.
      2: (iconParams: tIconParams);
  end;

function sUIIconRegisterB(): sUIIconRegister;

type
  sUIActionNotify_createWindowPtr = ^sUIActionNotify_createWindow;
  sUIActionNotify_createWindow = record
    sm: sUIActionNotify_base;
    hWnd: Cardinal;
    hwndParent: Cardinal;
    x: Integer;   ///< Pozycja X na ktrej trzeba wstawi okno. TRZEBA t warto zwikszy o szeroko utworzonego okna!
    y: Integer;///< Pozycja Y na ktrej trzeba wstawi okno. TRZEBA t warto zwikszy o wysoko utworzonego okna!
    Status: Cardinal; ///< Kopia wartoci \a status akcji
    txt: Pchar;
    flags :Cardinal;
    font :Cardinal;
    fontBold :Cardinal;
    w :Cardinal;
    h :Cardinal;
  end;

type
  sUIActionNotify_destroyWindowPtr = ^sUIActionNotify_destroyWindow;
  sUIActionNotify_destroyWindow = record
    sm: sUIActionNotify_base;
    hwnd:Cardinal;
    flags :Integer;
  end;

const
  ACTS_SHOW = 0;
  ACTS_HIDDEN = 1;
  ACTS_DISABLED = 2;
  ACTS_CHECKED = 4;
  ACTS_SELECTED = 8;
  ACTS_GROUP = $10;
  ACTSMENU_NOTRANS = $40;
  ACTSMENU_CHECKSPACE = $8000;
  ACTSMENU_BOLD = $100;
  ACTSBAR_BOTTOM = $20;
  ACTSBAR_NOALIGN = $40;
  ACTSBAR_VERT = $80;
  ACTSBAR_LOCKED = $100;
  ACTSBAND_FULL = $100;
  ACTSBAND_WRAP = $400;
  ACTSTB_DARROWS = $20;
  ACTSTB_MIXED = $40;
  ACTSTB_LIST = $80;
  ACTSTB_SHOWTEXT = $1000;
  ACTSTB_WHOLEDROPDOWN = $200;
  ACTSTB_WRAP = ACTSBAND_WRAP;
  ACTSTB_OPAQUE = $800;
  ACTSC_INT = $20;
  ACTSC_INLINE = $40;
  ACTSC_FULLWIDTH = $80;
  ACTSC_BOLD = $100;
  ACTSC_NEEDRESTART = $200;
  ACTSCOMBO_LIST = $1000;
  ACTSCOMBO_SORT = $2000;
  ACTSCOMBO_BYPOS = $4000;
  ACTSCOMBO_NOICON = $8000;
  ACTSRADIO_BYPOS = $1000;
  ACTSRADIO_LAST = $2000;
  ACTSTIME_SHOWNONE = $1000;
  ACTSTIME_UPDOWN = $2000;
  ACTSFONT_CHECKBOX = $4000;
  ACTSFONT_NOCOLOR = $8000;
  ACTSFONT_NOBGCOLOR = $400;
  ACTSFONT_NOSIZE = $800;
  ACTSFONT_NOFACE = $1000;
  ACTSFONT_NOSTYLE = $2000;
  ACTSCOLOR_CHECKBOX = $1000;
  ACTSINFO_CENTER = $1000;
  ACTSBUTTON_ALIGNRIGHT = $1000;

const
  ACTT_SEP = $10000;
  ACTT_SEPARATOR = ACTT_SEP;
  ACTT_BREAK = $20000;
  ACTT_BARBREAK = $30000;
  ACTT_BAND = $40000;
  ACTT_HWND = $50000;
  ACTT_CHECK = $60000;
  ACTT_CHECKGROUP = $70000;
  ACTT_INFO = $80000;
  ACTT_COMMENT = $90000;
  ACTT_HOLDER = $A0000;
  ACTT_EDIT = $B0000;
  ACTT_TEXT = $C0000;
  ACTT_PASSWORD = $D0000;
  ACTT_BUTTON = $E0000;
  ACTT_GROUP = $F0000;
  ACTT_GROUPEND = $100000;
  ACTT_IMAGE = $110000;
  ACTT_FILE = $120000;
  ACTT_DIR = $130000;
  ACTT_COLOR = $140000;
  ACTT_FONT = $150000;
  ACTT_COMBO = $160000;
  ACTT_TIME = $170000;
  ACTT_HTMLINFO = $180000;
  ACTT_RADIO = $190000;
  ACTT_SPINNER = $1A0000;
  ACTT_SLIDER = $1B0000;
  ACTT_TIPBUTTON = $1C0000;

const
  ACTR_INIT = $1000000;
  ACTR_SHOW = $2000000;
  ACTR_SAVE = $4000000;
  ACTR_CHECK = $8000000;
  ACTR_RESIZE = $10000000;
  ACTR_STATUS = $20000000;
  ACTR_SETCNT = $20000000;
  ACTR_CONVERT = $40000000;
  ACTR_GETSET = ACTR_CONVERT;
  ACTR_NODATASTORE = $80000000;

const
  ACTN_ACTION = 1;
  ACTN_GROUP = 2;
  ACTN_CREATE = 10;
  ACTN_CREATEGROUP = 19;
  ACTN_DESTROY = 11;
  ACTN_SHOW = 12;
  ACTN_HIDE = 13;
  ACTN_SAVE = 14;
  ACTN_RESIZE = 15;
  ACTN_STATUS = 16;
  ACTN_DEFAULT = 17;
  ACTN_SETCNT = 18;
  ACTN_CHECK = 100;
  ACTN_GET = 101;
  ACTN_SET = 102;
  ACTN_CONVERT_TO = 103;
  ACTN_CONVERT_FROM = 104;
  ACTN_FILEOPEN = 201;
  ACTN_FILEOPENED = 202;
  ACTN_DROP = 210;
  ACTN_CREATEWINDOW = 220;
  ACTN_DESTROYWINDOW = 221;
  
const
  AP_VALUE = #2;
  AP_ICO = #3;
  AP_PARAMS = #4;
  AP_RADIOGRP = EXT_PARAM + 'grp=';
  AP_MINIMUM = EXT_PARAM + 'min=';
  AP_MAXIMUM = EXT_PARAM + 'max=';
  AP_STEP = EXT_PARAM + 'step=';
  AP_TIP_OBSOLETE = Chr(1);
  AP_TIP = EXT_PARAM + 'tip=';
  AP_TIP_WIDTH = EXT_PARAM + 'tipWidth=';
  AP_TIPRICH = EXT_PARAM + 'tipRich=';
  AP_TIPRICH_WIDTH = AP_TIP_WIDTH;
  AP_TIPTITLE = EXT_PARAM + 'tipTitle=';
  AP_TIPIMAGEURL = EXT_PARAM + 'tipImg=';
  AP_TIPICON = EXT_PARAM + 'tipIco=';
  AP_TIPICONURL = EXT_PARAM + 'tipIcoUrl=';
  AP_IMGURL = EXT_PARAM + 'imgurl=';
  AP_ICONSIZE = EXT_PARAM + 'iconsize=';
  AP_ICONDEPTH = EXT_PARAM + 'icondepth=';
  AP_MINWIDTH = EXT_PARAM + 'minWidth=';
  AP_MINHEIGHT = EXT_PARAM + 'minHeigt=';
  AP_MAXWIDTH = EXT_PARAM + 'maxWidth=';
  AP_MAXHEIGHT = EXT_PARAM + 'maxHeight=';
  AP_BESTWIDTH = EXT_PARAM + 'best-Width=';
  AP_BESTHEIGHT = EXT_PARAM + 'bestHeight=';
  CFGVALUE = AP_VALUE;
  CFGICO = AP_ICO;
  CFGTIP = AP_TIP;
  EXT_PARAM_CHAR = #26;
  MEX_ADDINFO ='AddInfo';
  MEX_DISPLAY ='Display';
  MEX_TITLE  = 'Title';
  MEX_NOSOUND = 'NoSound';
  MEX_FILE_PATH = 'FilePath';
  MEX_FILE_SIZE = 'FileSize';
  MEX_FILE_TRANSFER_TIME = 'FileTransferTime';
  MEX_FILE_TRANSFERED = 'FileTransfered';
  MEX_FILE_ERROR = 'FileError';

const
  Konnekt_UI_ACT_msg_ctrlview = 250;
  Konnekt_UI_ACT_msg_ctrlsend = 251;
  Konnekt_UI_Notify_insertMsg = 310;

const
  PLUGP_LOWEST = $10;
  PLUGP_LOW = $40;
  PLUGP_STANDARD = $80;
  PLUGP_HIGH = $B0;
  PLUGP_HIGHEST = $E0;
  PLUGP_NONE = $0;

const
  CFG_DESCR_AWAY = 125;
  CFG_DESCR_AAWAY = 126;
  CFG_DESCR_DND = 127;
  CFG_DESCR_HIDDEN = 128;
  CFG_DESCR_ONLINE = 130;
  CFG_DESCR_OFFLINE = 131;
  CFG_DESCR_USEMANUAL = 141;
  CFG_DESCR_CLEARMANUAL = 169;

implementation

function UIIcon(type_: Integer; net: Integer; id: Integer; frame: Integer): Integer;
begin
  Result := (((frame)and $F) or (((id) and $FFFF) shl 4) or (((net) and $FF) shl 20) or (((type_) and $F) shl 28));
end;

function sUIIconRegisterB(): sUIIconRegister;
var
  ir: sUIIconRegister;
begin
  ir.s_size := SizeOf(ir);
  ir.target := IML_NONE;
  ir.URL := nil;
  ir.imgHandle := 0;
  ir.maskHandle := 0;
  ir.imgInst := 0;
  ir.imgId := 0;
  ir.imgType := 0;
  Result := ir;
end;

end.
